SoVRMLCylinderSensor(3)

NAME
SoVRMLCylinderSensor - The SoVRMLCylinderSensor class maps pointer motion into rotations around the Y-axis.

SYNOPSIS

#include <Inventor/VRMLnodes/SoVRMLCylinderSensor>

Inherits SoVRMLDragSensor.

  Public Member Functions
virtual SoType getTypeId (void) const
SoVRMLCylinderSensor (void)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Public Attributes
SoSFFloat diskAngle
SoSFFloat maxAngle
SoSFFloat minAngle
SoSFFloat offset
SoSFRotation rotation_changed

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual SbBool dragStart (void)
virtual void drag (void)
virtual void dragFinish (void)
virtual ~SoVRMLCylinderSensor ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoVRMLCylinderSensor class maps pointer motion into rotations around the Y-axis. The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

CylinderSensor {
  exposedField SFBool     autoOffset TRUE
  exposedField SFFloat    diskAngle  0.262       # (0,/2)
  exposedField SFBool     enabled    TRUE
  exposedField SFFloat    maxAngle   -1          # [-2,2]
  exposedField SFFloat    minAngle   0           # [-2,2]
  exposedField SFFloat    offset     0           # (-inf, inf)
  eventOut     SFBool     isActive
  eventOut     SFRotation rotation_changed
  eventOut     SFVec3f    trackPoint_changed
}

The CylinderSensor node maps pointer motion (e.g., a mouse or wand) into a rotation on an invisible cylinder that is aligned with the Y-axis of the local coordinate system. The CylinderSensor uses the descendent geometry of its parent node to determine whether it is liable to generate events.

The enabled exposed field enables and disables the CylinderSensor node. If TRUE, the sensor reacts appropriately to user events. If FALSE, the sensor does not track user input or send events. If enabled receives a FALSE event and isActive is TRUE, the sensor becomes disabled and deactivated, and outputs an isActive FALSE event. If enabled receives a TRUE event the sensor is enabled and ready for user activation.

A CylinderSensor node generates events when the pointing device is activated while the pointer is indicating any descendent geometry nodes of the sensor's parent group. See 4.6.7.5, Activating and manipulating sensors (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.5), for more details on using the pointing device to activate the CylinderSensor.

Upon activation of the pointing device while indicating the sensor's geometry, an isActive TRUE event is sent. The initial acute angle between the bearing vector and the local Y-axis of the CylinderSensor node determines whether the sides of the invisible cylinder or the caps (disks) are used for manipulation. If the initial angle is less than the diskAngle, the geometry is treated as an infinitely large disk lying in the local Y=0 plane and coincident with the initial intersection point. Dragging motion is mapped into a rotation around the local +Y-axis vector of the sensor's coordinate system. The perpendicular vector from the initial intersection point to the Y-axis defines zero rotation about the Y-axis. For each subsequent position of the bearing, a rotation_changed event is sent that equals the sum of the rotation about the +Y-axis vector (from the initial intersection to the new intersection) plus the offset value. trackPoint_changed events reflect the unclamped drag position on the surface of this disk. When the pointing device is deactivated and autoOffset is TRUE, offset is set to the last value of rotation_changed and an offset_changed event is generated. See 4.6.7.4, Drag sensors (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.4), for a more general description of autoOffset and offset fields.

If the initial acute angle between the bearing vector and the local Y-axis of the CylinderSensor node is greater than or equal to diskAngle, then the sensor behaves like a cylinder. The shortest distance between the point of intersection (between the bearing and the sensor's geometry) and the Y-axis of the parent group's local coordinate system determines the radius of an invisible cylinder used to map pointing device motion and marks the zero rotation value. For each subsequent position of the bearing, a rotation_changed event is sent that equals the sum of the right-handed rotation from the original intersection about the +Y-axis vector plus the offset value. trackPoint_changed events reflect the unclamped drag position on the surface of the invisible cylinder. When the pointing device is deactivated and autoOffset is TRUE, offset is set to the last rotation angle and an offset_changed event is generated. More details are available in 4.6.7.4, Drag sensors (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.4).

When the sensor generates an isActive TRUE event, it grabs all further motion events from the pointing device until it is released and generates an isActive FALSE event (other pointing-device sensors shall not generate events during this time). Motion of the pointing device while isActive is TRUE is referred to as a 'drag.' If a 2D pointing device is in use, isActive events will typically reflect the state of the primary button associated with the device (i.e., isActive is TRUE when the primary button is pressed and FALSE when it is released). If a 3D pointing device (e.g., a wand) is in use, isActive events will typically reflect whether the pointer is within or in contact with the sensor's geometry.

While the pointing device is activated, trackPoint_changed and rotation_changed events are output and are interpreted from pointing device motion based on the sensor's local coordinate system at the time of activation. trackPoint_changed events represent the unclamped intersection points on the surface of the invisible cylinder or disk. If the initial angle results in cylinder rotation (as opposed to disk behaviour) and if the pointing device is dragged off the cylinder while activated, browsers may interpret this in a variety of ways (e.g., clamp all values to the cylinder and continuing to rotate as the point is dragged away from the cylinder). Each movement of the pointing device while isActive is TRUE generates trackPoint_changed and rotation_changed events. The minAngle and maxAngle fields clamp rotation_changed events to a range of values. If minAngle is greater than maxAngle, rotation_changed events are not clamped.

The minAngle and maxAngle fields are restricted to the range [-2, 2]. More information about this behaviour is described in 4.6.7.3, Pointing-device sensors, 4.6.7.4, Drag sensors (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.4), and 4.6.7.5 (http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.5), Activating and manipulating sensors.

Constructor & Destructor Documentation

  SoVRMLCylinderSensor::SoVRMLCylinderSensor (void)
Constructor.

  SoVRMLCylinderSensor::~SoVRMLCylinderSensor () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoVRMLCylinderSensor::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoVRMLCylinderSensor::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoVRMLDragSensor.

  const SoFieldData ** SoVRMLCylinderSensor::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoVRMLCylinderSensor::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoVRMLDragSensor.

  void SoVRMLCylinderSensor::initClass (void) [static]

  SbBool SoVRMLCylinderSensor::dragStart (void) [protected], [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Called when dragger is selected (picked) by the user.

Implements SoVRMLDragSensor.

  void SoVRMLCylinderSensor::drag (void) [protected], [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Called when user drags the mouse after picking the dragger.

Implements SoVRMLDragSensor.

  void SoVRMLCylinderSensor::dragFinish (void) [protected], [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Called when mouse button is released after picking and interacting with the dragger.

Implements SoVRMLDragSensor.

Member Data Documentation

  SoSFFloat SoVRMLCylinderSensor::diskAngle
Angle where sensor starts to behave like a disk.

  SoSFFloat SoVRMLCylinderSensor::maxAngle
Maximum angle around Y-axis.

  SoSFFloat SoVRMLCylinderSensor::minAngle
Minimum angle around Y-axis.

  SoSFFloat SoVRMLCylinderSensor::offset
Current rotation value. Initial value is 0.0.

  SoSFRotation SoVRMLCylinderSensor::rotation_changed
This eventOut is signaled during sensor interaction.

Author

Generated automatically by Doxygen for Coin from the source code.